/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  filesystem_Directory.c */
/* class: Directory */

#include <ferite.h>       /* we need this without a doubt */
#include "filesystem_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_destructor_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 745 "filesystem.fec"

    
        if(self->odata)
        {
            closedir((DIR *)self->odata);
            self->odata = NULL;
            FE_RETURN_TRUE;
        }
        FE_RETURN_FALSE;
    
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_constructor_s )
{
   FeriteString *directory;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &directory );

   { /* Main function body. */
#line 656 "filesystem.fec"

    
        if(self->odata) closedir((DIR *)self->odata);
        if(!(self->odata = opendir(directory->data)))
        {
            ferite_set_error(script, errno, "%s", strerror(errno));
            FE_RETURN_NULL_OBJECT;
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_getEntry_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 679 "filesystem.fec"

    
        struct dirent *de;
        FeriteVariable *fv;
        
        if(!self->odata)
        {
            ferite_set_error(script, EBADF, "The directory stream is not"
                             "open");
            fv = ferite_create_string_variable_from_ptr(script, "", "", 0, FE_CHARSET_DEFAULT, FE_STATIC);
            FE_RETURN_VAR(fv);
        }
        
        errno = 0;
        if(!(de = readdir((DIR *)self->odata)))
        {
            if(errno)
                ferite_set_error(script, errno, "%s", strerror(errno));
            else ferite_set_error(script, 0, "");
            fv = ferite_create_string_variable_from_ptr(script, "", "", 0, FE_CHARSET_DEFAULT, FE_STATIC);
        }
        else
        {
            fv = ferite_create_string_variable_from_ptr(script,
                                                        "Sys::Dir::readdir", de->d_name, 0,
                                                        FE_CHARSET_DEFAULT, FE_STATIC);
        }
        FE_RETURN_VAR(fv);
    
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_getCurrent_ )
{
   FeriteClass *self = FE_CONTAINER_TO_CLASS;

   { /* Main function body. */
#line 547 "filesystem.fec"

    
        int len = 128;
        FeriteVariable *v;
        char *buf, *ret = NULL;
        
        if((buf = fmalloc(len)))
        {
            do
            {
                if(!(ret = getcwd(buf, len - 1)) && errno == ERANGE)
                {
                    len *= 2;
                    buf = frealloc(buf, len);
                }
            }
            while(!ret && buf && errno == ERANGE);
        }
        
        if(ret)
        {
            v = fe_new_str_static("Sys::getcwd", ret, 0, FE_CHARSET_DEFAULT);
        }
        else
        {
            ferite_set_error(script, errno, "%s", strerror(errno));
            v = fe_new_str_static("", "", 0, FE_CHARSET_DEFAULT);
        }
        if(buf) ffree(buf);
        FE_RETURN_VAR(v);
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_setCurrent_s )
{
   FeriteString *path;
   FeriteClass *self = FE_CONTAINER_TO_CLASS;

   ferite_get_parameters( params, 1, &path );

   { /* Main function body. */
#line 586 "filesystem.fec"

    
        if( chdir( path->data ) == -1 )
        {
            ferite_set_error( script, errno, "%s", strerror( errno ) );
            FE_RETURN_FALSE;
        }
        FE_RETURN_TRUE;
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_filesystem_Directory_make_sn )
{
   FeriteString *dirname;
   double mode;
   FeriteClass *self = FE_CONTAINER_TO_CLASS;

   ferite_get_parameters( params, 2, &dirname, &mode );

   { /* Main function body. */
#line 531 "filesystem.fec"

    
        if( mkdir( dirname->data, (mode_t)mode ) == -1 )
        {
            ferite_set_error( script, errno, "%s", strerror(errno) );
            FE_RETURN_FALSE;
        }
        FE_RETURN_TRUE;
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

