/* This file has been automatically generated by builder part of the ferite distribution */
/* file: math_Math.c */
/* namespace: Math */

#include <ferite.h>       /* we need this without a doubt */
#include "math_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( ferite_math_Math_sqrt_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 369 "math.fec"

    
        if( num < 0 )
          ferite_error( script, 0, "Math.sqrt() can only take positive values\n" );
        else
        {
            FE_RETURN_DOUBLE( sqrt( num ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_atan_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 110 "math.fec"

    
        if( degree < -1 || degree > 1 )
            ferite_error( script, 0, "Math.atan() can only take values between -1 and 1\n" );
        else
        {
            FE_RETURN_DOUBLE( atan( degree ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_tan_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 386 "math.fec"

    
        FE_RETURN_DOUBLE( tan( degree ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_log10_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 220 "math.fec"

    
        if( num <= 0 )
          ferite_error( script, 0, "Math.log10() can only take positive values\n" );
        else
        {
            FE_RETURN_DOUBLE( log10( num ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_max_nn )
{
   double num1;
   double num2;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 2, &num1, &num2 );

   { /* Main function body. */
#line 238 "math.fec"

    
        if( num1 < num2 )
        {
            FE_RETURN_DOUBLE( num2 );
        }
        else
        {
            FE_RETURN_DOUBLE( num1 );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_log_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 203 "math.fec"

    
        if( num <= 0 )
          ferite_error( script, 0, "Math.log() can only take positive values\n" );
        else
        {
            FE_RETURN_DOUBLE( log( num ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_rand_ )
{
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   { /* Main function body. */
#line 304 "math.fec"

    
        FE_RETURN_LONG( rand() );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_ceil_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 144 "math.fec"

    
        FE_RETURN_DOUBLE( ceil( num ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_isLong_n )
{
   double n;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &n );

   { /* Main function body. */
#line 414 "math.fec"

    
        if( params[0]->type == F_VAR_LONG )
        {
            FE_RETURN_TRUE;
        }
        FE_RETURN_FALSE;
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_acos_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 73 "math.fec"

    
        if( degree < -1 || degree > 1 )
          ferite_error( script, 0, "Math.acos() can only take values between -1 and 1\n" );
        else
        {
            FE_RETURN_DOUBLE( acos( degree ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_cos_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 156 "math.fec"

    
        FE_RETURN_DOUBLE( cos( degree ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_getRandMax_ )
{
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   { /* Main function body. */
#line 191 "math.fec"

    
        FE_RETURN_LONG( RAND_MAX );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_floor_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 180 "math.fec"

    
        FE_RETURN_DOUBLE( floor( num ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_round_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 344 "math.fec"

    
        int sign = (num < 0 ? -1 : 1 );
        FE_RETURN_LONG( (long)(num+(0.5 * sign)) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_min_nn )
{
   double num1;
   double num2;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 2, &num1, &num2 );

   { /* Main function body. */
#line 258 "math.fec"

    
        if( num1 > num2 )
        {
            FE_RETURN_DOUBLE( num2 );
        }
        else
        {
            FE_RETURN_DOUBLE( num1 );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_atan2_nn )
{
   double x;
   double y;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 2, &x, &y );

   { /* Main function body. */
#line 132 "math.fec"

    
        FE_RETURN_DOUBLE( atan2( x, y ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_abs_n )
{
   double num;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &num );

   { /* Main function body. */
#line 56 "math.fec"

    
	if( params[0]->type == F_VAR_DOUBLE )
            FE_RETURN_DOUBLE( fabs( num ) );
        FE_RETURN_LONG( labs( (long)num ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_asin_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 93 "math.fec"

    
        if( degree < -1 || degree > 1 )
          ferite_error( script, 0, "Math.asin() can only take values between -1 and 1\n" );
        else
        {
            FE_RETURN_DOUBLE( asin( degree ) );
        }
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_sin_n )
{
   double degree;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &degree );

   { /* Main function body. */
#line 357 "math.fec"

    
        FE_RETURN_DOUBLE( sin( degree ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_srand_n )
{
   double seed;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &seed );

   { /* Main function body. */
#line 325 "math.fec"

    
        srand( (long)seed );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_pow_nn )
{
   double base;
   double exp;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 2, &base, &exp );

   { /* Main function body. */
#line 289 "math.fec"

    
        FE_RETURN_DOUBLE( pow( base, exp ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_pi_ )
{
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   { /* Main function body. */
#line 276 "math.fec"

    
        FE_RETURN_DOUBLE( M_PI );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_isDouble_n )
{
   double n;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &n );

   { /* Main function body. */
#line 398 "math.fec"

    
        if( params[0]->type == F_VAR_DOUBLE )
        {
            FE_RETURN_TRUE;
        }
        FE_RETURN_FALSE;
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_math_Math_exp_n )
{
   double power;
   FeriteNamespace *self = FE_CONTAINER_TO_NS;

   ferite_get_parameters( params, 1, &power );

   { /* Main function body. */
#line 168 "math.fec"

    
        FE_RETURN_DOUBLE( exp( power ) );
    
   }
   FE_RETURN_VOID;
   self = NULL;
}

