/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  reflection_Function.c */
/* class: Function */

#include <ferite.h>       /* we need this without a doubt */
#include "reflection_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( ferite_reflection_Function_exec_E )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, NULL );

   { /* Main function body. */
#line 948 "reflection.fec"

   
       FeriteVariable *var, *dup;
       FeriteVariable **np;
       int i = 0;
       int cp = ferite_get_parameter_count(params);
       np = ferite_create_parameter_list(cp+3);

       for(i = 0; i < cp ; i++)
       {
           FUD(("number of real params: '%d'\n",cp));
           var = params[i];
           FUD(("param %d: '%s' type '%s'\n",i,var->name, ferite_variable_id_to_str(script,var->type)));
           if(var->type == F_VAR_STR)
           {
               FUD(("\tvalue='%s'\n",VAS(var)));
           }
           np[i] = ferite_duplicate_variable( script, var, NULL);
           MARK_VARIABLE_AS_DISPOSABLE(np[i]);
       }

       FUD(("arg count: '%d'\n",FunctionObj->func->arg_count));
       FUD(("calling '%s'...\n",FunctionObj->func->name));

       dup = ferite_call_function(script, FunctionObj->container, current_yield_block, FunctionObj->func, np);
       ferite_delete_parameter_list(script,np);
       FUD(("finished\n"));

       if( dup != NULL )
       {
           FE_RETURN_VAR(dup);
       }
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Function_execWithArray_a )
{
   FeriteUnifiedArray *args;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &args );

   { /* Main function body. */
#line 1000 "reflection.fec"

   
       FeriteVariable **plist = ferite_create_parameter_list( args->size + 3 );
       FeriteVariable *rval = NULL;
       int i = 0;

       for( i = 0; i < args->size; i++ ) {
           plist[i] = ferite_duplicate_variable( script, args->array[i], NULL );
           MARK_VARIABLE_AS_DISPOSABLE(plist[i]);
       }
       rval = ferite_call_function( script, FunctionObj->container, current_yield_block, FunctionObj->func, plist );
       ferite_delete_parameter_list( script, plist );
       if( rval != NULL )
       {
           FE_RETURN_VAR( rval );
       }
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Function_destructor_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 926 "reflection.fec"

   
       if( FunctionObj != NULL )
         ffree( self->odata );
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Function_constructor_vs )
{
   FeriteVariable *o = params[0];
   FeriteString *f;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 2, NULL, &f );

   { /* Main function body. */
#line 897 "reflection.fec"

   
       self->odata = fmalloc( sizeof( FunctionHolder ) );
       FunctionObj->func = NULL;
       switch( o->type )
       {
           case F_VAR_OBJ:
               FunctionObj->func = ferite_object_get_function(script,VAO(o),f->data);
               break;
           case F_VAR_NS:
           {
               FeriteNamespaceBucket *nsb = ferite_find_namespace(script,VAN(o),f->data,FENS_FNC);
               if( nsb != NULL )
                   FunctionObj->func = nsb->data;
               break;
           }
           case F_VAR_CLASS:
               FunctionObj->func = ferite_class_get_function(script,VAC(o),f->data);
               break;               
       }
       FunctionObj->container = VAP(o);

       if( FunctionObj->func == NULL )
       {
           ffree( self->odata );
           FE_RETURN_NULL_OBJECT;
       }
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Function_constructor_s )
{
   FeriteString *f;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &f );

   { /* Main function body. */
#line 877 "reflection.fec"

   
       FeriteNamespaceBucket *nsb = NULL;

       self->odata = fmalloc( sizeof( FunctionHolder ) );
       FunctionObj->container = script->mainns;
       
       nsb = ferite_find_namespace(script,script->mainns,f->data,FENS_PARENT_NS);
       if( nsb != NULL )
           FunctionObj->container = nsb->data;

       nsb = ferite_find_namespace(script,script->mainns,f->data,FENS_FNC);
       if( nsb != NULL )
           FunctionObj->func = nsb->data;
       else
       {
           ffree( self->odata );
           FE_RETURN_NULL_OBJECT;
       }
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Function_getParameterDetails_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 1038 "reflection.fec"

   
       int i = 0, argcount = FunctionObj->func->arg_count;
       FeriteVariable *retval = NULL, *newvar = NULL;

       retval = ferite_create_uarray_variable( script, "Function.getParameterDetails", FunctionObj->func->arg_count, FE_STATIC );
       for( i = 0; i < argcount; i++ )
       {
           if( strcmp( FunctionObj->func->signature[i]->variable->name, "..." ) != 0 )
           {
               newvar = ferite_create_string_variable_from_ptr( script, "",
                                                                ferite_variable_id_to_str( script,
                                                                                           FunctionObj->func->signature[i]->variable->type ),
                                                                0, FE_CHARSET_DEFAULT, FE_STATIC );
           }
           else
             newvar = ferite_create_string_variable_from_ptr( script, "", "...", 0, FE_CHARSET_DEFAULT, FE_STATIC );
           ferite_uarray_add( script, VAUA(retval), newvar, FunctionObj->func->signature[i]->variable->name, FE_ARRAY_ADD_AT_END );
       }
       FE_RETURN_VAR( retval );
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

