/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  reflection_Object.c */
/* class: Object */

#include <ferite.h>       /* we need this without a doubt */
#include "reflection_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( ferite_reflection_Object_getVariables_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 740 "reflection.fec"

   
       FeriteHashBucket *buk;
       FeriteVariable *array, *var;
       FeriteIterator *iter;
       FeriteObjectVariable *variables;
       char *buf;

       buf = FE_CLEAN_STRING(1024);
       array = ferite_create_uarray_variable(script, "Object::getVars", 32, FE_STATIC);
       iter = ferite_create_iterator(script);
       
       for( variables = ObjectObj->variables; variables != NULL; variables = variables->parent )
       {
           memset( iter, 0, sizeof(FeriteIterator) );
           while((buk = (FeriteHashBucket*)ferite_hash_walk(script,variables->variables,iter)) != NULL)
           {
               var = buk->data;
               
               if( !FE_VAR_IS_STATIC(var) && var->state == FE_ITEM_IS_PUBLIC && ferite_uarray_get_from_string(script,VAUA(array),var->name) == NULL )
               {
                   ferite_uarray_add(script,VAUA(array),
                                     ferite_duplicate_variable(script,var, NULL),
                                     var->name,FE_ARRAY_ADD_AT_END);
               }
           }
       }
       ffree( buf );
       ffree( iter );
       FE_RETURN_VAR(array);
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_getVariable_s )
{
   FeriteString *name;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &name );

   { /* Main function body. */
#line 621 "reflection.fec"

   
       FeriteVariable *var = ferite_object_get_var( script, ObjectObj, name->data );

       if( var == NULL )
       {
           ferite_error( script, 0, "Object.getVariable(\"%s\") - No such variable in object\n", name->data );
           FE_RETURN_VOID;
       }

       /* We dont do FE_RETURN_VAR because we dont want the variable to be disposed */
       return var;
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_className_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 550 "reflection.fec"

   
       FeriteVariable *v;
       v = fe_new_str_static("className",ObjectObj->name, 0, FE_CHARSET_DEFAULT);
       FE_RETURN_VAR(v);
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_setVariables_a )
{
   FeriteUnifiedArray *vars;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &vars );

   { /* Main function body. */
#line 790 "reflection.fec"

   
       FeriteHashBucket *buk;
       FeriteIterator *iter;
       FeriteVariable *var;

       iter = ferite_create_iterator(script);
       while((buk = (FeriteHashBucket*)ferite_hash_walk(script,vars->hash,iter)) != NULL)
       {
           if(ferite_object_has_var(script,ObjectObj,buk->id))
           {
               var = ferite_duplicate_variable( script, buk->data, NULL );
               ferite_object_set_var(script,ObjectObj,buk->id,var);
           }
       }
       ffree(iter);
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_getObject_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 694 "reflection.fec"

   
       FE_RETURN_OBJECT( ObjectObj );
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_destructor_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 535 "reflection.fec"

   
       ObjectObj->refcount--;
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_constructor_o )
{
   FeriteObject *obj;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &obj );

   { /* Main function body. */
#line 522 "reflection.fec"

   
       if(obj != NULL)
       {
           self->odata = obj;
           obj->refcount++;
       }
       else
       {
           ferite_error(script,0,"Invalid object (a null object?)");
       }
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_setVariable_sv )
{
   FeriteString *name;
   FeriteVariable *value = params[1];
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 2, &name, NULL );

   { /* Main function body. */
#line 655 "reflection.fec"

   
       FeriteVariable *var = ferite_object_get_var( script, ObjectObj, name->data );
       FeriteVariable *rval = NULL;

       if( var == NULL )
       {
           ferite_error( script, 0, "Object.setVariable(\"%s\") - No such variable in object\n", name->data );
           FE_RETURN_VOID;
       }

       if( !ferite_types_are_equal( script, var->type, value->type ) )
       {
           ferite_error( script, 0, "Object.setVariable(\"%s\") - can't assign variable of type %s to type %s\n",
                         name->data,
                         ferite_variable_id_to_str( script, value->type ),
                         ferite_variable_id_to_str( script, var->type ) );
           FE_RETURN_VOID;
       }

       rval = ferite_op_assign( script, var, value );
       FE_RETURN_VAR( rval );
   
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_hasMember_os )
{
   FeriteObject *o;
   FeriteString *member;
   FeriteClass *self = FE_CONTAINER_TO_CLASS;

   ferite_get_parameters( params, 2, &o, &member );

   { /* Main function body. */
#line 827 "reflection.fec"

   
       if( o != NULL )
       {
           if( ferite_object_get_var( script, o, member->data ) != NULL )
           {
               FE_RETURN_TRUE;
           }
           if( ferite_object_get_function( script, o, member->data ) != NULL )
           {
               FE_RETURN_TRUE;
           }
       }
       FE_RETURN_FALSE;
   
   }
   FE_RETURN_VOID;
   self = NULL;
}

FE_NATIVE_FUNCTION( ferite_reflection_Object_fromData_sa )
{
   FeriteString *klass;
   FeriteUnifiedArray *data;
   FeriteClass *self = FE_CONTAINER_TO_CLASS;

   ferite_get_parameters( params, 2, &klass, &data );

   { /* Main function body. */
#line 579 "reflection.fec"

   
       FeriteVariable *obj = NULL;
       FeriteHashBucket *buk = NULL;
       FeriteIterator *iter = NULL;
       FeriteVariable *foo = NULL;
       FeriteClass *cls = ferite_find_class(script,script->mainns,klass->data);

       obj = ferite_build_object(script,cls);
       iter = ferite_create_iterator(script);
       while((buk = (FeriteHashBucket*)ferite_hash_walk(script,data->hash,iter)) != NULL)
       {
           if(ferite_object_has_var(script,VAO(obj),buk->id))
           {
               foo = fe_new_void_static( "no-var" );
               ferite_variable_destroy( script, ferite_op_assign( script, foo, (FeriteVariable*)buk->data ) );
               ferite_object_set_var(script, VAO(obj), buk->id, foo);
           }
       }
       ffree(iter);
       FE_RETURN_VAR( obj );
   
   }
   FE_RETURN_VOID;
   self = NULL;
}

